"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .useractivityinsight import UserActivityInsight, UserActivityInsightTypedDict
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AiInsightsResponseTypedDict(TypedDict):
    last_log_timestamp: NotRequired[int]
    r"""Unix timestamp of the last activity processed to make the response (in seconds since epoch UTC)."""
    assistant_insights: NotRequired[List[UserActivityInsightTypedDict]]
    total_active_assistant_users: NotRequired[int]
    r"""Total number of Active Assistant users (chat, summary, AIA) in requested period."""
    total_chat_messages: NotRequired[int]
    r"""Total number of Chat messages sent in requested period."""
    total_ai_summarizations: NotRequired[int]
    r"""Total number of AI Document Summarizations invoked in the requested period."""
    total_ai_answers: NotRequired[int]
    r"""Total number of AI Answers generated in the requested period."""
    total_upvotes: NotRequired[int]
    r"""Total number of Chat messages which received upvotes by the user."""
    total_downvotes: NotRequired[int]
    r"""Total number of Chat messages which received downvotes by the user."""
    total_gleanbot_responses: NotRequired[int]
    r"""Total number of Gleanbot responses, both proactive and reactive."""
    total_gleanbot_responses_shared: NotRequired[int]
    r"""Total number of Gleanbot responses shared publicly (upvoted)."""
    total_gleanbot_responses_not_helpful: NotRequired[int]
    r"""Total number of Glean responses rejected as not helpful (downvoted)."""
    departments: NotRequired[List[str]]
    r"""list of departments applicable for users tab."""


class AiInsightsResponse(BaseModel):
    last_log_timestamp: Annotated[
        Optional[int], pydantic.Field(alias="lastLogTimestamp")
    ] = None
    r"""Unix timestamp of the last activity processed to make the response (in seconds since epoch UTC)."""

    assistant_insights: Annotated[
        Optional[List[UserActivityInsight]], pydantic.Field(alias="assistantInsights")
    ] = None

    total_active_assistant_users: Annotated[
        Optional[int], pydantic.Field(alias="totalActiveAssistantUsers")
    ] = None
    r"""Total number of Active Assistant users (chat, summary, AIA) in requested period."""

    total_chat_messages: Annotated[
        Optional[int], pydantic.Field(alias="totalChatMessages")
    ] = None
    r"""Total number of Chat messages sent in requested period."""

    total_ai_summarizations: Annotated[
        Optional[int], pydantic.Field(alias="totalAiSummarizations")
    ] = None
    r"""Total number of AI Document Summarizations invoked in the requested period."""

    total_ai_answers: Annotated[
        Optional[int], pydantic.Field(alias="totalAiAnswers")
    ] = None
    r"""Total number of AI Answers generated in the requested period."""

    total_upvotes: Annotated[Optional[int], pydantic.Field(alias="totalUpvotes")] = None
    r"""Total number of Chat messages which received upvotes by the user."""

    total_downvotes: Annotated[
        Optional[int], pydantic.Field(alias="totalDownvotes")
    ] = None
    r"""Total number of Chat messages which received downvotes by the user."""

    total_gleanbot_responses: Annotated[
        Optional[int], pydantic.Field(alias="totalGleanbotResponses")
    ] = None
    r"""Total number of Gleanbot responses, both proactive and reactive."""

    total_gleanbot_responses_shared: Annotated[
        Optional[int], pydantic.Field(alias="totalGleanbotResponsesShared")
    ] = None
    r"""Total number of Gleanbot responses shared publicly (upvoted)."""

    total_gleanbot_responses_not_helpful: Annotated[
        Optional[int], pydantic.Field(alias="totalGleanbotResponsesNotHelpful")
    ] = None
    r"""Total number of Glean responses rejected as not helpful (downvoted)."""

    departments: Optional[List[str]] = None
    r"""list of departments applicable for users tab."""
