"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .datasourcegroupdefinition import (
    DatasourceGroupDefinition,
    DatasourceGroupDefinitionTypedDict,
)
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BulkIndexGroupsRequestTypedDict(TypedDict):
    r"""Describes the request body for the /bulkindexgroups API call"""

    upload_id: str
    r"""Unique id that must be used for this instance of datasource groups upload"""
    datasource: str
    r"""datasource of the groups"""
    groups: List[DatasourceGroupDefinitionTypedDict]
    r"""batch of groups for the datasource"""
    is_first_page: NotRequired[bool]
    r"""true if this is the first page of the upload. Defaults to false"""
    is_last_page: NotRequired[bool]
    r"""true if this is the last page of the upload. Defaults to false"""
    force_restart_upload: NotRequired[bool]
    r"""Flag to discard previous upload attempts and start from scratch. Must be specified with isFirstPage=true"""
    disable_stale_data_deletion_check: NotRequired[bool]
    r"""True if older group data needs to be force deleted after the upload completes. Defaults to older data being deleted only if the percentage of data being deleted is less than a reasonable threshold. This must only be set when `isLastPage = true`"""


class BulkIndexGroupsRequest(BaseModel):
    r"""Describes the request body for the /bulkindexgroups API call"""

    upload_id: Annotated[str, pydantic.Field(alias="uploadId")]
    r"""Unique id that must be used for this instance of datasource groups upload"""

    datasource: str
    r"""datasource of the groups"""

    groups: List[DatasourceGroupDefinition]
    r"""batch of groups for the datasource"""

    is_first_page: Annotated[Optional[bool], pydantic.Field(alias="isFirstPage")] = None
    r"""true if this is the first page of the upload. Defaults to false"""

    is_last_page: Annotated[Optional[bool], pydantic.Field(alias="isLastPage")] = None
    r"""true if this is the last page of the upload. Defaults to false"""

    force_restart_upload: Annotated[
        Optional[bool], pydantic.Field(alias="forceRestartUpload")
    ] = None
    r"""Flag to discard previous upload attempts and start from scratch. Must be specified with isFirstPage=true"""

    disable_stale_data_deletion_check: Annotated[
        Optional[bool], pydantic.Field(alias="disableStaleDataDeletionCheck")
    ] = None
    r"""True if older group data needs to be force deleted after the upload completes. Defaults to older data being deleted only if the percentage of data being deleted is less than a reasonable threshold. This must only be set when `isLastPage = true`"""
