"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .externalshortcut import ExternalShortcut, ExternalShortcutTypedDict
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BulkIndexShortcutsRequestTypedDict(TypedDict):
    r"""Describes the request body of the /bulkindexshortcuts API call"""

    upload_id: str
    r"""Unique id that must be used for this bulk upload instance"""
    shortcuts: List[ExternalShortcutTypedDict]
    r"""Batch of shortcuts information"""
    is_first_page: NotRequired[bool]
    r"""true if this is the first page of the upload. Defaults to false"""
    is_last_page: NotRequired[bool]
    r"""true if this is the last page of the upload. Defaults to false"""
    force_restart_upload: NotRequired[bool]
    r"""Flag to discard previous upload attempts and start from scratch. Must be specified with isFirstPage=true"""


class BulkIndexShortcutsRequest(BaseModel):
    r"""Describes the request body of the /bulkindexshortcuts API call"""

    upload_id: Annotated[str, pydantic.Field(alias="uploadId")]
    r"""Unique id that must be used for this bulk upload instance"""

    shortcuts: List[ExternalShortcut]
    r"""Batch of shortcuts information"""

    is_first_page: Annotated[Optional[bool], pydantic.Field(alias="isFirstPage")] = None
    r"""true if this is the first page of the upload. Defaults to false"""

    is_last_page: Annotated[Optional[bool], pydantic.Field(alias="isLastPage")] = None
    r"""true if this is the last page of the upload. Defaults to false"""

    force_restart_upload: Annotated[
        Optional[bool], pydantic.Field(alias="forceRestartUpload")
    ] = None
    r"""Flag to discard previous upload attempts and start from scratch. Must be specified with isFirstPage=true"""
