"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .documentspec_union import DocumentSpecUnion, DocumentSpecUnionTypedDict
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ChatRestrictionFiltersTypedDict(TypedDict):
    container_specs: NotRequired[List[DocumentSpecUnionTypedDict]]
    r"""Specifications for containers that should be used as part of the restriction (include/exclude). Memberships are recursively defined for a subset of datasources (currently: SharePoint, OneDrive, Google Drive, and Confluence). Please contact the Glean team to enable this for more datasources. Recursive memberships do not apply for Collections."""
    document_specs: NotRequired[List[DocumentSpecUnionTypedDict]]
    datasource_instances: NotRequired[List[str]]


class ChatRestrictionFilters(BaseModel):
    container_specs: Annotated[
        Optional[List[DocumentSpecUnion]], pydantic.Field(alias="containerSpecs")
    ] = None
    r"""Specifications for containers that should be used as part of the restriction (include/exclude). Memberships are recursively defined for a subset of datasources (currently: SharePoint, OneDrive, Google Drive, and Confluence). Please contact the Glean team to enable this for more datasources. Recursive memberships do not apply for Collections."""

    document_specs: Annotated[
        Optional[List[DocumentSpecUnion]], pydantic.Field(alias="documentSpecs")
    ] = None

    datasource_instances: Annotated[
        Optional[List[str]], pydantic.Field(alias="datasourceInstances")
    ] = None
