"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ExternalShortcutTypedDict(TypedDict):
    input_alias: str
    r"""link text following the viewPrefix as entered by the user. For example, if the view prefix is `go/` and the shortened URL is `go/abc`, then `abc` is the inputAlias."""
    destination_url: str
    r"""destination URL for the shortcut."""
    created_by: str
    r"""Email of the user who created this shortcut."""
    intermediate_url: str
    r"""The URL from which the user is then redirected to the destination URL."""
    description: NotRequired[str]
    r"""A short, plain text blurb to help people understand the intent of the shortcut."""
    create_time: NotRequired[int]
    r"""The time the shortcut was created in epoch seconds."""
    updated_by: NotRequired[str]
    r"""Email of the user who last updated this shortcut."""
    update_time: NotRequired[int]
    r"""The time the shortcut was updated in epoch seconds."""
    title: NotRequired[str]
    r"""Title of the golink"""
    decayed_visit_score: NotRequired[float]
    r"""decayed visits score for ranking"""
    edit_url: NotRequired[str]
    r"""The URL using which the user can access the edit page of the shortcut."""


class ExternalShortcut(BaseModel):
    input_alias: Annotated[str, pydantic.Field(alias="inputAlias")]
    r"""link text following the viewPrefix as entered by the user. For example, if the view prefix is `go/` and the shortened URL is `go/abc`, then `abc` is the inputAlias."""

    destination_url: Annotated[str, pydantic.Field(alias="destinationUrl")]
    r"""destination URL for the shortcut."""

    created_by: Annotated[str, pydantic.Field(alias="createdBy")]
    r"""Email of the user who created this shortcut."""

    intermediate_url: Annotated[str, pydantic.Field(alias="intermediateUrl")]
    r"""The URL from which the user is then redirected to the destination URL."""

    description: Optional[str] = None
    r"""A short, plain text blurb to help people understand the intent of the shortcut."""

    create_time: Annotated[Optional[int], pydantic.Field(alias="createTime")] = None
    r"""The time the shortcut was created in epoch seconds."""

    updated_by: Annotated[Optional[str], pydantic.Field(alias="updatedBy")] = None
    r"""Email of the user who last updated this shortcut."""

    update_time: Annotated[Optional[int], pydantic.Field(alias="updateTime")] = None
    r"""The time the shortcut was updated in epoch seconds."""

    title: Optional[str] = None
    r"""Title of the golink"""

    decayed_visit_score: Annotated[
        Optional[float], pydantic.Field(alias="decayedVisitScore")
    ] = None
    r"""decayed visits score for ranking"""

    edit_url: Annotated[Optional[str], pydantic.Field(alias="editUrl")] = None
    r"""The URL using which the user can access the edit page of the shortcut."""
