"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .customentity import CustomEntity, CustomEntityTypedDict
from .entitiessortorder import EntitiesSortOrder
from .facetresult import FacetResult, FacetResultTypedDict
from .person import Person, PersonTypedDict
from .team import Team, TeamTypedDict
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ListEntitiesResponseTypedDict(TypedDict):
    results: NotRequired[List[PersonTypedDict]]
    team_results: NotRequired[List[TeamTypedDict]]
    custom_entity_results: NotRequired[List[CustomEntityTypedDict]]
    facet_results: NotRequired[List[FacetResultTypedDict]]
    cursor: NotRequired[str]
    r"""Pagination cursor. A previously received opaque token representing the position in the overall results at which to start."""
    total_count: NotRequired[int]
    r"""The total number of entities available"""
    has_more_results: NotRequired[bool]
    r"""Whether or not more entities can be fetched."""
    sort_options: NotRequired[List[EntitiesSortOrder]]
    r"""Sort options from EntitiesSortOrder supported for this response. Default is empty list."""
    custom_facet_names: NotRequired[List[str]]
    r"""list of Person attributes that are custom setup by deployment"""


class ListEntitiesResponse(BaseModel):
    results: Optional[List[Person]] = None

    team_results: Annotated[
        Optional[List[Team]], pydantic.Field(alias="teamResults")
    ] = None

    custom_entity_results: Annotated[
        Optional[List[CustomEntity]], pydantic.Field(alias="customEntityResults")
    ] = None

    facet_results: Annotated[
        Optional[List[FacetResult]], pydantic.Field(alias="facetResults")
    ] = None

    cursor: Optional[str] = None
    r"""Pagination cursor. A previously received opaque token representing the position in the overall results at which to start."""

    total_count: Annotated[Optional[int], pydantic.Field(alias="totalCount")] = None
    r"""The total number of entities available"""

    has_more_results: Annotated[
        Optional[bool], pydantic.Field(alias="hasMoreResults")
    ] = None
    r"""Whether or not more entities can be fetched."""

    sort_options: Annotated[
        Optional[List[EntitiesSortOrder]], pydantic.Field(alias="sortOptions")
    ] = None
    r"""Sort options from EntitiesSortOrder supported for this response. Default is empty list."""

    custom_facet_names: Annotated[
        Optional[List[str]], pydantic.Field(alias="customFacetNames")
    ] = None
    r"""list of Person attributes that are custom setup by deployment"""
