"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .scopetype import ScopeType
from glean.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class WritePermissionTypedDict(TypedDict):
    r"""Describes the write permissions levels that a user has for a specific feature"""

    scope_type: NotRequired[ScopeType]
    r"""Describes the scope for a ReadPermission, WritePermission, or GrantPermission object"""
    create: NotRequired[bool]
    r"""True if user has create permission for this feature and scope"""
    update: NotRequired[bool]
    r"""True if user has update permission for this feature and scope"""
    delete: NotRequired[bool]
    r"""True if user has delete permission for this feature and scope"""


class WritePermission(BaseModel):
    r"""Describes the write permissions levels that a user has for a specific feature"""

    scope_type: Annotated[Optional[ScopeType], pydantic.Field(alias="scopeType")] = None
    r"""Describes the scope for a ReadPermission, WritePermission, or GrantPermission object"""

    create: Optional[bool] = None
    r"""True if user has create permission for this feature and scope"""

    update: Optional[bool] = None
    r"""True if user has update permission for this feature and scope"""

    delete: Optional[bool] = None
    r"""True if user has delete permission for this feature and scope"""
